function LV = BMLV(y,S0,r,q,T,L,sigma,alpha,A0)

N = length(sigma);

% Integrated vols under constant sigma case
V = sigma.*sqrt(T);

% Adjust y and S0 for the A0 shift
y  = y  - A0*alpha*exp((r-q)*T);
S0 = S0 - A0*alpha*exp((r-q)*T);

% Equation (3.3) of Brigo and Mercurio
for i=1:N
    num(i) = L(i)/V(i)*exp(-0.5/V(i)^2*(log(y/S0) - (r-q)*T + 0.5*V(i)^2)^2) * sigma(i)^2;
    den(i) = L(i)/V(i)*exp(-0.5/V(i)^2*(log(y/S0) - (r-q)*T + 0.5*V(i)^2)^2);
end

LV = sqrt(sum(num)/sum(den));

