function y = BMObjFun(param,MktIV,S0,r,q,K,T,N)

% Break up the parameter vector into components
sigma = param(1:N);         % Constant volatilities
L     = param(N+1:2*N-1);   % Weights lambda
alpha = param(2*N);         % Alpha parameter
L(N)  = 1-sum(L);           % Last weight

NK = length(K);
NT = length(T);

% Model implied volatility and error term
for t=1:NT
    for k=1:NK
        IV(k,t) = BMIV(K(k),S0,r,q,T(t),alpha,L,sigma);
        error(k,t) = (IV(k,t) - MktIV(k,t))^2 / MktIV(k,t)^2;
    end
end

y = sum(sum(error));

for i=1:N;
    % Penalty for weights beyond (0,1)
    if L(i)<=0.01 || L(i)>=.99
        y = 1e100;
    end
    % Penalty for negative volatilities
    if sigma(i)<=0.01;
        y = 1e100;
    end
end


